#include <stdlib.h>
#include "xmms/plugin.h"
#include "xmms/util.h"
#include "render.h"

/*
 * Basically just a wrapper for the calls in 
 * render.c
 */


static void ktp_init(void);
static void ktp_cleanup(void);
static void ktp_about(void);
static void ktp_render_freq(gint16 data[2][256]);


VisPlugin ktp_vp =
{
	NULL,
	NULL,
	0,
	"OpenGL Terrain Plugin 0.11",
	0,
	256,		
	ktp_init, /* init */
	ktp_cleanup, /* cleanup */
	ktp_about, /* about */
	NULL, /* configure */
	NULL, /* disable_plugin */
	NULL, /* playback_start */
	NULL, /* playback_stop */
	NULL, /* render_pcm */
	ktp_render_freq  /* render_freq */
};


VisPlugin *get_vplugin_info(void)
{
  return &ktp_vp;
}


static void ktp_init(void)
{
  TerrainInit();
}

static void ktp_cleanup(void)
{
  TerrainDestroy();
}


static void ktp_about(void)
{
  GtkWidget *dialog;
  dialog = xmms_show_message("About libxtp", "OpenGL Terrain Plugin 0.11"
			     "\nDraws terrain based on the music\n"
			     "you are listening to.\n\n"
			     "by Keith Ito <keithito@stanford.edu>", 
			     "Close", FALSE, NULL, NULL);
  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		     GTK_SIGNAL_FUNC(gtk_widget_destroyed),
		     &dialog);
}


static void ktp_render_freq(gint16 data[2][256])
{
  UpdateHeightField(data[0], data[1]);
  TerrainRender();
}


